VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CSyncDir"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

Private Const mcMODE_LOCAL As Long = 1
Private Const mcMODE_SERVER As Long = 2

' Xe[^XʒmP
Private Const mcSTATE_NOTICE_UNIT_COUNT As Long = 10

Private m_SyncDataList As Collection

Private m_LocalBaseDir As String
Private m_ServerBaseDir As String

Private m_ErrorMessage As String

Private m_SaveFileName As String

Private m_FilterAction(acFILTER_FIRST To acFILTER_LAST) As Boolean
Private m_FilterStatus(stFILTER_FIRST To stFILTER_LAST) As Boolean
Private m_FileFilter As String
Private m_DirFilter As String
Private m_Fudge As Long

Private m_NeedSave As Boolean

'**
' Search\bhAԂύXꂽĂяoCxg
' @param Message ύX
Public Event StateChanged(ByVal Message As String)


Private Declare Function GetTickCount Lib "kernel32" () As Long


'==============================================================================
' JvpeBE\bh
'==============================================================================

'**
' [Jx[XfBNg
Public Property Get LocalBaseDir() As String
    LocalBaseDir = m_LocalBaseDir
End Property
Public Property Let LocalBaseDir(ByVal NewLocalBaseDir As String)
    If m_LocalBaseDir <> NewLocalBaseDir Then
        m_LocalBaseDir = NewLocalBaseDir
        m_NeedSave = True
    End If
End Property

'**
' T[ox[XfBNg
Public Property Get ServerBaseDir() As String
    ServerBaseDir = m_ServerBaseDir
End Property
Public Property Let ServerBaseDir(ByVal NewServerBaseDir As String)
    If m_ServerBaseDir <> NewServerBaseDir Then
        m_ServerBaseDir = NewServerBaseDir
        m_NeedSave = True
    End If
End Property

'**
' G[bZ[W
Public Property Get ErrorMessage() As String
    ErrorMessage = m_ErrorMessage
End Property

'**
' Z[ut@C
Public Property Get SaveFileName() As String
    SaveFileName = m_SaveFileName
End Property

'**
' tB^F
Public Property Get FilterStatus(ByVal Index As EnumStatus) As Boolean
    'u덷vuf[^vȂCR[ƓƂ
    Select Case Index
     Case stFudge, stDataEquals
        Index = stEquals
    End Select
    FilterStatus = m_FilterStatus(Index)
End Property
Public Property Let FilterStatus(ByVal Index As EnumStatus, ByVal NewFilterStatus As Boolean)
    If m_FilterStatus(Index) <> NewFilterStatus Then
        m_FilterStatus(Index) = NewFilterStatus
        m_NeedSave = True
    End If
End Property

'**
' tB^F
Public Property Get FilterAction(ByVal Index As EnumAction) As Boolean
    FilterAction = m_FilterAction(Index)
End Property
Public Property Let FilterAction(ByVal Index As EnumAction, ByVal NewFilterAction As Boolean)
    If m_FilterAction(Index) <> NewFilterAction Then
        m_FilterAction(Index) = NewFilterAction
        m_NeedSave = True
    End If
End Property

'**
' tB^Ft@C̃ChJ[h
Public Property Get FileFilter() As String
    FileFilter = m_FileFilter
End Property
Public Property Let FileFilter(ByVal NewFileFilter As String)
    If m_FileFilter <> NewFileFilter Then
        m_FileFilter = NewFileFilter
        m_NeedSave = True
    End If
End Property

'**
' tB^FtH_̃Xg
Public Property Get DirFilter() As String
    DirFilter = m_DirFilter
End Property
Public Property Let DirFilter(ByVal NewDirFilter As String)
    If m_DirFilter <> NewDirFilter Then
        m_DirFilter = NewDirFilter
        m_NeedSave = True
    End If
End Property

'**
' tB^F덷
Public Property Get Fudge() As Long
    Fudge = m_Fudge
End Property
Public Property Let Fudge(ByVal NewFudge As Long)
    If m_Fudge <> NewFudge Then
        m_Fudge = NewFudge
        m_NeedSave = True
    End If
End Property

'**
' ۑȂႢȂǂ
Public Property Get IsNeedSave() As Boolean
    IsNeedSave = m_NeedSave
End Property

'**
' For Each p
Public Function NewEnum() As IUnknown
Attribute NewEnum.VB_UserMemId = -4
Attribute NewEnum.VB_MemberFlags = "40"
    Set NewEnum = m_SyncDataList.[_NewEnum]
End Function

'**
' CSyncData
Public Property Get item(ByVal Index As Variant) As CSyncData
Attribute item.VB_UserMemId = 0
Attribute item.VB_MemberFlags = "200"
    Set item = m_SyncDataList.item(Index)
End Property

'**
' 
Public Property Get count() As Long
    count = m_SyncDataList.count
End Property


'**
' ݒǍ
' @return ǍɐTrue
Public Function LoadData(ByVal LoadFileName As String) As Boolean
    Dim ini As CIniFile
    
    If LoadFileName = "" Then Exit Function
    
    't@CȂΎs
    If Dir$(LoadFileName) = "" Then
        LoadData = False
        Exit Function
    End If
    
    Set ini = New CIniFile
    If Not ini.Load(LoadFileName) Then
        LoadData = False
        Exit Function
    End If
    m_SaveFileName = LoadFileName
    
    With ini
        .NowSection = "Setting"
        m_LocalBaseDir = .InitData("LocalBaseDir", eIniType_String, CurDir$)
        m_ServerBaseDir = .InitData("ServerBaseDir", eIniType_String, CurDir$)
        
        .NowSection = "Filter"
        m_FilterStatus(stLocalNew) = .InitData("StatusLocalNew", eIniType_Boolean, True)
        m_FilterStatus(stLocalOnly) = .InitData("StatusLocalOnly", eIniType_Boolean, True)
        m_FilterStatus(stServerNew) = .InitData("StatusServerNew", eIniType_Boolean, True)
        m_FilterStatus(stServerOnly) = .InitData("StatusServerOnly", eIniType_Boolean, True)
        m_FilterStatus(stEquals) = .InitData("StatusEquals", eIniType_Boolean, True)
        m_FilterAction(acLocalToServer) = .InitData("ActionLocalToServer", eIniType_Boolean, True)
        m_FilterAction(acServerToLocal) = .InitData("ActionServerToLoacl", eIniType_Boolean, True)
        m_FilterAction(acNone) = .InitData("ActionNone", eIniType_Boolean, True)
        m_FilterAction(acEquals) = .InitData("ActionEquals", eIniType_Boolean, True)
        m_FileFilter = .InitData("FileFilter", eIniType_String, "*.*")
        m_DirFilter = .InitData("DirFilter", eIniType_String, "")
        m_Fudge = .InitData("Fudge", eIniType_Long, 0)
    End With
    
    LoadData = True
End Function

'**
' ݒۑ
' @return ۑɐTrue
Public Function SaveData(Optional ByVal SaveFileName As String = "") As Boolean
    Dim ini As CIniFile
    
    If SaveFileName = "" Then
        SaveFileName = m_SaveFileName
    End If
    
    If SaveFileName = "" Then Exit Function
    
    Set ini = New CIniFile
    If Not ini.Load(SaveFileName) Then
        SaveData = False
        Exit Function
    End If
    
    With ini
        .NowSection = "Setting"
        .Data("LocalBaseDir") = m_LocalBaseDir
        .Data("ServerBaseDir") = m_ServerBaseDir
    
        .NowSection = "Filter"
        .Data("StatusLocalNew") = Me.FilterStatus(stLocalNew)
        .Data("StatusLocalOnly") = Me.FilterStatus(stLocalOnly)
        .Data("StatusServerNew") = Me.FilterStatus(stServerNew)
        .Data("StatusServerOnly") = Me.FilterStatus(stServerOnly)
        .Data("StatusEquals") = Me.FilterStatus(stEquals)
        .Data("ActionLocalToServer") = Me.FilterAction(acLocalToServer)
        .Data("ActionServerToLocal") = Me.FilterAction(acServerToLocal)
        .Data("ActionNone") = Me.FilterAction(acNone)
        .Data("ActionEquals") = Me.FilterAction(acEquals)
        .Data("FileFilter") = Me.FileFilter
        .Data("DirFilter") = Me.DirFilter
        .Data("Fudge") = Me.Fudge
    End With
    
    SaveData = ini.Save
    If SaveData Then
        m_NeedSave = False
        m_SaveFileName = SaveFileName
    End If
End Function


'**
' 
' @return TrueBsɂErrorMessageɃG[ei[B
Public Function Search() As Boolean
    Dim LocalList() As String
    Dim ServerList() As String
    
    '`FbN
    If Not ExistDirectory(m_LocalBaseDir) Then
        m_ErrorMessage = m_LocalBaseDir & "̓tH_ł͂܂B"
        Exit Function
    ElseIf Not ExistDirectory(m_ServerBaseDir) Then
        m_ErrorMessage = m_ServerBaseDir & "̓tH_ł͂܂B"
        Exit Function
    ElseIf m_LocalBaseDir = m_ServerBaseDir Then
        m_ErrorMessage = "tH_rĂ傤ȂłB"
        Exit Function
    Else
        m_ErrorMessage = ""
    End If
    
    'Xg擾
    RaiseEvent StateChanged(m_LocalBaseDir & "̃Xg擾...")
    LocalList = getFileList(m_LocalBaseDir)
    RaiseEvent StateChanged(m_ServerBaseDir & "̃Xg擾...")
    ServerList = getFileList(m_ServerBaseDir)
    
    'rȂCollectionɒǉ
    RaiseEvent StateChanged("}[W...")
    Call addCollection(LocalList, ServerList)

    'tbVĊ
    Search = Refresh()
End Function

'**
' tbV
Public Function Refresh() As Boolean
    Dim Data As CSyncData
    Dim Size As Long
    Dim count As Long

    Refresh = True
    Size = m_SyncDataList.count
    count = 1
    For Each Data In Me
        If Not Data.Refresh(m_Fudge) Then
            Refresh = False
            Exit For
        End If
        If count Mod mcSTATE_NOTICE_UNIT_COUNT = 0 Then
            RaiseEvent StateChanged("Ԏ擾(" & count & "/" & Size & ")")
        End If
        count = count + 1
    Next Data
    RaiseEvent StateChanged("Ԏ擾")
End Function

'**
' t@CtB^̃`FbN
' @param Ώۃt@C
Public Function CheckFileFilter(ByVal FileName As String) As Boolean
    Dim FilterList() As String
    Dim i As Long
    
    If m_FileFilter = "" Then
        CheckFileFilter = True
        Exit Function
    End If
    
    FilterList = Split(m_FileFilter, ";")
    For i = LBound(FilterList) To UBound(FilterList)
        If FileName Like FilterList(i) Then
            CheckFileFilter = True
            Exit Function
        End If
    Next i
End Function

'**
' tH_tB^̃`FbN
' @param ΏۃtH_
Public Function CheckDirFilter(ByVal DirName As String) As Boolean
    Dim FilterList() As String
    Dim i As Long
    
    If m_DirFilter = "" Then
        CheckDirFilter = True
        Exit Function
    End If
    
    FilterList = Split(m_DirFilter, ";")
    For i = LBound(FilterList) To UBound(FilterList)
        If DirName Like FilterList(i) & "*" Then
            CheckDirFilter = True
            Exit Function
        End If
    Next i
End Function



'==============================================================================
' vCx[g\bh
'==============================================================================

'**
' t@CXgm}[W
' @param LocalList [Jt@CXg
' @param ServerList T[ot@CXg
Private Sub addCollection(ByRef LocalList() As String, ByRef ServerList() As String)
    Dim localPos As Long, serverPos As Long
    Dim localEnd As Long, serverEnd As Long
    Dim i As Long
    Dim localData As CSyncData
    Dim serverData As CSyncData
    
    'Xg
    Set m_SyncDataList = Nothing
    Set m_SyncDataList = New Collection
    
    'ʒu擾
    localPos = LBound(LocalList) - 1
    localEnd = UBound(LocalList)
    serverPos = LBound(ServerList) - 1
    serverEnd = UBound(ServerList)

    '}[W
    Set localData = getNextSyncData(LocalList, localPos)
    Set serverData = getNextSyncData(ServerList, serverPos)
    
    Do Until localData Is Nothing And serverData Is Nothing

        Select Case True
         Case localData Is Nothing
            Call addList(serverData)

            Set serverData = getNextSyncData(ServerList, serverPos)
         
         Case serverData Is Nothing
            Call addList(localData)
            Set localData = getNextSyncData(LocalList, localPos)
         
         Case UCase$(localData.Path) = UCase$(serverData.Path)
         
            Select Case True
             Case UCase$(localData.Name) = UCase$(serverData.Name)
                Call addList(localData)
                Set localData = getNextSyncData(LocalList, localPos)
                Set serverData = getNextSyncData(ServerList, serverPos)
            
             Case UCase$(localData.Name) < UCase$(serverData.Name)
                Call addList(localData)
                Set localData = getNextSyncData(LocalList, localPos)
                
             Case UCase$(localData.Name) > UCase$(serverData.Name)
                Call addList(serverData)
                Set serverData = getNextSyncData(ServerList, serverPos)
                            
            End Select
            
         Case UCase$(localData.Path) < UCase$(serverData.Path)
            Call addList(localData)
            Set localData = getNextSyncData(LocalList, localPos)
            
         Case UCase$(localData.Path) > UCase$(serverData.Path)
            Call addList(serverData)
            Set serverData = getNextSyncData(ServerList, serverPos)
                        
        End Select
    Loop
End Sub

Private Function addList(ByRef Data As CSyncData) As Boolean
    On Error GoTo ErrorHandler
    Call m_SyncDataList.Add(Data, Data.Key)
    
    addList = True
Exit Function

ErrorHandler:
    Select Case Err.Number
     Case 0
        '
     Case 457       'Ɋ蓖ĂĂ
        Resume Next
     Case Else
        On Error GoTo 0
        Resume
    End Select
End Function

Private Function getNextSyncData(ByRef pathList() As String, ByRef Index As Long) As CSyncData
    If Index < UBound(pathList) Then
        Set getNextSyncData = New CSyncData
        Index = Index + 1
        Call getNextSyncData.Init(0, m_LocalBaseDir, m_ServerBaseDir, pathList(Index))
    Else
        Set getNextSyncData = Nothing
    End If
End Function

Private Function executeConsole(ByVal Command As String) As String
    Dim tmpFile As String
    Dim cmdStr As String
    Dim FNum As Integer
    Dim buf As String
    
    tmpFile = CreateTempFile()
    cmdStr = Environ$("COMSPEC") & " /c " & Command & " >" & tmpFile
    Call CreateObject("WScript.Shell").run(cmdStr, True, vbNormalNoFocus)
    FNum = FreeFile()
    buf = Space$(FileLen(tmpFile))
    Open tmpFile For Binary As #FNum
        Get #FNum, , buf
    Close #FNum
    
    executeConsole = Left$(buf, InStr(buf & vbNullChar, vbNullChar) - 1)
    
    Call Kill(tmpFile)
End Function

Private Function getFileList(ByVal Path As String) As String()
    Dim cmdStr As String
    Dim buffs() As String
    Dim i As Long
    Dim cnt As Long
    
    cmdStr = "dir /o:n /b /s """ & Path & """"
    buffs = Split(executeConsole(cmdStr), vbCrLf)
    
    cnt = 0
    For i = LBound(buffs) To UBound(buffs)
        If buffs(i) = "" Then
            'ȂɂȂ
        ElseIf (GetAttr(buffs(i)) And vbDirectory) = vbDirectory Then
            'fBNg͔΂
        Else
            If InStr(UCase$(buffs(i)), UCase$(Path)) = 1 Then
                buffs(i) = Mid$(buffs(i), Len(Path) + 1)
                If Left$(buffs(i), 1) = "\" Then
                    buffs(i) = Mid$(buffs(i), 2)
                End If
            End If
            buffs(cnt) = buffs(i)
            cnt = cnt + 1
        End If
    Next i
    If cnt = 0 Then
        buffs = Split("")
    Else
        ReDim Preserve buffs(cnt - 1)
    End If
    
    getFileList = buffs
End Function

Private Function ExistDirectory(ByVal Path As String) As Boolean
    Dim buf As String
    buf = Dir$(Path, vbDirectory)
    If buf = "" Then
        ExistDirectory = False
    Else
        If (GetAttr(Path) And vbDirectory) = vbDirectory Then
            ExistDirectory = True
        Else
            ExistDirectory = False
        End If
    End If
End Function

Private Sub Class_Initialize()
    Dim i As Long

    Set m_SyncDataList = New Collection
    
    m_LocalBaseDir = CurDir()
    m_ServerBaseDir = CurDir()
        
    m_FileFilter = "*.*"
    For i = LBound(m_FilterStatus) To UBound(m_FilterStatus)
        m_FilterStatus(i) = True
    Next i
    For i = LBound(m_FilterAction) To UBound(m_FilterAction)
        m_FilterAction(i) = True
    Next i
    
    m_NeedSave = False
End Sub

Private Sub Class_Terminate()
    Set m_SyncDataList = Nothing
End Sub
